import CodeMirror from 'codemirror';
import { useRef, useEffect, createElement } from 'react';

var Mode;
(function (Mode) {
    Mode["JavaScript"] = "javascript";
    Mode["Markdown"] = "markdown";
})(Mode || (Mode = {}));
var CodeEditor = function (_a) {
    var defaultValue = _a.defaultValue, mode = _a.mode, onChange = _a.onChange, _b = _a.lineNumbers, lineNumbers = _b === void 0 ? false : _b;
    var textAreaEl = useRef(null);
    useEffect(function () {
        var codeMirror = CodeMirror.fromTextArea(textAreaEl.current, {
            lineNumbers: lineNumbers,
            mode: mode
        });
        codeMirror.on("change", function (obj) {
            onChange(obj.getValue());
        });
    }, []);
    return (createElement("textarea", { "data-testid": "textarea", ref: textAreaEl, defaultValue: defaultValue }));
};

export { CodeEditor, Mode as CodeEditorMode };
